<?php
/*
Plugin Name: WP Hashtag
Plugin URI: http://borneolab.org
Description: Enable Wordpress engine to create hashtags like twitter. It's not grab popular hash from twitter, This plugin allow you to create your own hashtag just by adding <code>#yourtagname</code> to post editor.
Author: Ganda Manurung(http://gandamanurung.com), Aan Afdi(http://planet-orange.org)
Version: 1.0.1
Author URI: http://borneolab.org
Credits : Original idea is by Aan Afdi(http://planet-orange.org)
*/

#
#  Copyright (c) 2010 Borneo Lab
#
#  WP-Hashtag is free software; you can redistribute it and/or modify it under
#  the terms of the GNU General Public License as published by the Free
#  Software Foundation; either version 2 of the License, or (at your option)
#  any later version.
#
#  WP-Hashtag is distributed in the hope that it will be useful, but WITHOUT ANY
#  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
#  FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
#  details. http://www.gnu.org/licenses/license-list.html#GPLCompatibleLicenses
#

$use_prefix = 'true';
$saved_prefix = get_option('wpht_url_prefix');

if (!defined("WP_CONTENT_URL")) define("WP_CONTENT_URL", get_option("siteurl") . "/wp-content");
if (!defined("WP_PLUGIN_URL"))  define("WP_PLUGIN_URL",  WP_CONTENT_URL        . "/plugins");

function wp_hashtag_style()
{
  $css_url = WP_PLUGIN_URL . "/wp_hashtag/wp_hashtag.css";
  if (file_exists(TEMPLATEPATH . "/wp_hashtag.css"))
  {
    $css_url = get_bloginfo("template_url") . "/wp_hashtag.css";
  }
  echo "\n".'<link rel="stylesheet" href="' . $css_url . '" type="text/css" media="screen" />'."\n";
}

function wp_hashtag_filter($content)
{
    global $post, $wpdb, $saved_prefix;
    $saved_prefix = ($saved_prefix=='')? 'true' : $saved_prefix;
    $the_prefix = ($saved_prefix=='true')? '#' : '';
    $pattern = '/\s*#[a-zA-Z0-9-_]+(\s+|\.+|,+)/i';
    preg_match_all($pattern, $content, $matches, PREG_OFFSET_CAPTURE);
    $hashtag_array = $matches[0];
    $numoftag = count($hashtag_array);
    $the_tag = array();
    
    for($i=0;$i<$numoftag;$i++)
    {
        $hash_tag[] = trim(trim($hashtag_array[$i][0]), ".,");
        $the_tag[] = substr($hash_tag[$i], 1);
        $hash_tag_pattern[$i] = '/'.$hash_tag[$i].'/';
    }
    
    $hash_tag_pattern = array_values(array_unique($hash_tag_pattern));
    
    $replacement = array();
    foreach($the_tag as $value)
    {
        if(!is_term($value, 'post_tag'))
        {
            $term = wp_insert_term($value, 'post_tag');
            $wpdb->query($wpdb->prepare("INSERT INTO $wpdb->term_relationships SET object_id = %d, term_taxonomy_id = %d, term_order=0", $post->ID, $term['term_id']));
        }

        $exist_term = get_term_by('name', $value, 'post_tag');
        $exists_term_id = $exist_term->term_id;
        $sql = sprintf("SELECT object_id FROM $wpdb->term_relationships WHERE object_id = %d AND term_taxonomy_id = %d", $post->ID, $exists_term_id);
        $exists = $wpdb->get_var($sql);
        if(empty($exists))
        {
            $wpdb->query($wpdb->prepare("INSERT INTO $wpdb->term_relationships SET object_id = %d, term_taxonomy_id = %d, term_order=0", $post->ID, $exists_term_id));
        }
        $replacement[] = "<a href='" . esc_attr(get_term_link($value, 'post_tag')) . "' rel='tag' class=\"hashtag\">".$the_prefix.$value."</a>";
        $replacement = array_values(array_unique($replacement));
    }
    if(count($the_tag)>0)
        $content = preg_replace($hash_tag_pattern, $replacement, $content);
    return $content;
}

function wp_hashtag_config_page()
{
    if ( function_exists('add_submenu_page') )
        add_submenu_page('plugins.php', __('WP Hashtag'), __('WP Hashtag'), 'manage_options', 'wp-hashtag-config', 'wp_hashmap_conf');

}

function wp_hashmap_conf()
{
    global $use_prefix, $saved_prefix;
    if(get_option('wpht_url_prefix')=='')
        $use_prefix = 'true';
    else
        $use_prefix = get_option('wpht_url_prefix');
    
    if (isset($_POST['submit']) )
    {
        $prefix = $_POST['wpht_url_prefix'];
        $message = __("WP Hashtag options updated",'wp_hashtag');
            
        if ($prefix !== $use_prefix)
        {
            
            if(!update_option("wpht_url_prefix",$prefix))
                $message = "Update Failed";
            $use_prefix = $prefix;
        }
    }

?>
<?php if ( !empty($_POST['submit'] ) ) : ?>
    <div id="message" class="updated fade"><p><strong><?php _e($message) ?></strong></p></div>
<?php endif; ?>

        <div class="wrap">
        <h2><?php _e('WP Hashtag Configuration'); ?></h2>
        <p><?php _e("<a href=\"http://borneolab.org\">WP Hashtag</a> is a plugin to enable Wordpress engine to create hashtags like twitter. It's not grab popular hash from twitter, This plugin allow you to create your own hashtag.
        ");?> </p>
        <h3>WP Hashtag URL Prefix</h3>
        <form action="" method="post">
        <p><label><input type='radio' value="true" name='wpht_url_prefix'<?php if ( get_option('wpht_url_prefix')=='' || get_option('wpht_url_prefix') == 'true') echo ' checked="checked" '; ?> >Use <strong>#</strong> as prefix. <span>Your URL would be &lt;a href="..."&gt;#hashtag&lt;/a&gt; </span></label></p>
        <p><label><input type='radio' value="false" name='wpht_url_prefix' <?php if ( get_option('wpht_url_prefix') == 'false' ) echo ' checked="checked" '; ?>><strong>None</strong> <span>Your URL would be &lt;a href="..."&gt;hashtag&lt;/a&gt; </span></label></p>
        <p class="submit"><input type="submit" name="submit" value="<?php _e('Save changes'); ?>" /></p>
        </form>
        </div>
<?php
}
add_action('wp_head', 'wp_hashtag_style');
add_filter('the_content', 'wp_hashtag_filter', 0);
add_action('admin_menu', 'wp_hashtag_config_page');
?>